#!/usr/local/bin/ruby -w

$debug =  false
$run = false
$force = false
$cvs = false

class File
  def self.write_all_file path, data, mode = 'wb'
    open(path, mode) {|f| f.write data }
  end
end

def get_version_from_name( name )
  name2 = name.sub( /,[^,]*$/, '' )
  name2e = name2.gsub( /\+/, '.' )
  name4 = name.sub( /^#{name2e}/, '' )
  name3 = name2.sub(  /_[0-9][0-9]*$/, '' )
  name3e = name3.gsub( /\+/, '.' )
  name5 = name2.sub( /^#{name3e}/, '' )
  return [ name2, name3, name4, name5 ]
end

index = Hash.new
File.read( "INDEX-7" ).split( "\n" ).each do |line|
  wort = line.split( '|' )
  key = wort[1].sub( /\/usr\//, '' )
  key << "/Makefile"
  index[ key ] = wort[0]
end

while ARGV.nitems > 0
  makefile = ARGV.shift
  case makefile
  when /-d.*/
    $debug = true
    next
  when /-r.*/
    $run = true
    next
  when /-f.*/
    $force = true
    next
  when /-c.*/
    $cvs = true
    next
  end
  if makefile == 'ports/x11-themes/bluecurve-themes'
    next
  end
  if not index.has_key?( makefile )
    STDERR.puts( "not in index: #{makefile}" )
    next
  end
  dir = makefile.sub( /\/Makefile$/, '' )
  if $cvs
    diffversion=`cvs diff "#{makefile}" | grep "^< PORTREVISION" | head -1`
    diffversion.delete!( "\n" )
    diffversion.sub!( /^< PORTREVISION[?]*=[ \t]*/, '' )
    pkgversion=`cd "#{dir}" && make -V PORTREVISION`
    pkgversion.delete!( "\n" )
    diffversion = diffversion.to_i
    pkgversion = pkgversion.to_i
    if diffversion != pkgversion
      if ( diffversion  + 1 ) == pkgversion
#        STDERR.puts( "bad ok: #{makefile} #{diffversion} -> #{pkgversion}" )
        next
      end
      STDERR.puts( "bad bump: #{makefile} #{diffversion} -> #{pkgversion}" )
      next
    end
p diffversion
p pkgversion
  else
    ov = get_version_from_name( index[ makefile ] )
    pkgname=`cd "#{dir}" && make -V PKGNAME`
    pkgname.delete!( "\n" )
    nv = get_version_from_name( pkgname )
    if not $force
      if ov[1] != nv[1]
        ntest = nv[1].sub( /-(gnome|esound|imlib)/, '' )
        if ov[1] != ntest
p ov
p nv
          STDERR.puts( "updated: #{makefile} #{index[ makefile ]} -> #{pkgname}" )
          next
        end
      end
      if ov[2] == nv[2]
        val = ov[3].sub( /^_/, '' ).to_i
        val += 1
        otest = "_" + val.to_s
        if otest == nv[3]
          # STDERR.puts( "bump ok: #{makefile} #{index[ makefile ]} -> #{pkgname}" )
          next
        end
      end
      if ov[3] != nv[3]
p ov
p nv
        STDERR.puts( "bump fail: #{makefile} #{index[ makefile ]} -> #{pkgname}" )
        next
      end
    end
  end
  text = File.read( makefile )
  found = false
  n = nil
  o = nil
  bumped = ''
  text.each_line do |l|
    case l
    when /^PORTREVISION.*\{"/
      found = true
      bumped << l
p ov
p nv
      STDERR.puts( "slave : #{makefile} #{index[ makefile ]} -> #{pkgname}" )
      next
    when /^PORTREVISION/
      found = true
      o = l.dup
      n = l.sub( /=.*\n/, "=\t" )
      i = l.sub( /.*=[\t]*/, '' ).to_i
      n << "#{i + 1}\n"
      if /[$]/.match( o )
        bumped << "#"
        bumped << l
      end
      bumped << n
    when /^# *PORTREVISION/
      found = true
      o = l.dup
      n = l.sub( /=.*\n/, "=\t" )
      n.sub!( /^# */, '' )
      i = 0
      n << "#{i + 1}\n"
      if /[$]/.match( o )
        bumped << "#"
        bumped << l
      end
      bumped << n
    else
      bumped << l
    end
  end
  if not found
    bumped = ''
    text.each_line do |l|
     bumped << l
     case l
     when /^PORTVERSION/
      n = "PORTREVISION=\t1\n"
      bumped << n
      found = true
     end
    end
  end
  if not found
    bumped = ''
    text.each_line do |l|
     bumped << l
     case l
     when /^DISTVERSION/
      n = "PORTREVISION=\t1\n"
      bumped << n
      found = true
     end
    end
  end
  if text == bumped
    next
  end
  puts "changed: #{makefile}"
  if not o.nil?
    puts "- #{o}"
  end
  puts "+ #{n}"
  File.unlink(makefile)
  File.write_all_file( makefile, bumped )
end

# eof
